

#ifndef SWIRLING_BLOBBIES
#define SWIRLING_BLOBBIES

#include "Scheduler.h"

#include <OISEvents.h>

#include <Ogre.h>
using namespace Ogre;


class SwirlingBlob
{
	public:
		SwirlingBlob(BillboardSet* bbset, float size, unsigned long variance, float radius, Radian initialAngle);
		~SwirlingBlob();

		bool updatePosition(unsigned long elapsedMS);

	protected:
		BillboardSet* _bbset;
        Billboard* _blob;
		float _radius;
		Radian _angle;

		Scheduler::TaskId _taskId;
};


class SwirlingBlobbies : public Singleton<SwirlingBlobbies>
{
	public:
		SwirlingBlobbies(unsigned int initialBlobs);
		~SwirlingBlobbies();

		void keyboardCallback(const OIS::KeyEvent& arg);
		bool getMovingAverageSmoothing() const {return _movingAverageSmoothing;}

	protected:
		void increaseBlobNumbers(unsigned int number);
		void decreaseBlobNumbers(unsigned int number);
		void toggleSmoothingMethod();

	protected:
		SceneNode* _sceneNode;
		BillboardSet* _blobSet;
		typedef std::vector<SwirlingBlob*> BlobContainer;
		BlobContainer _largeBlobs;
		BlobContainer _mediumBlobs;
		BlobContainer _smallBlobs;

		float _nextRadius;

		bool _movingAverageSmoothing;
};


#endif