// COPYRIGHT  2005, Paul Bridger. All rights reserved.
// Licensed under the new BSD license: see license.txt for details


#define PYTHON_SCHEDULER
#include "BoostScheduler.h"


namespace Scheduler
{
	/** Get a python-capable frame locked queue
	
	We need to have Meyers-singleton functions here since python cannot instantiate templates
	(the types don't exist at C++ compile time unless they are being used).
	*/
	FrameLockedQueue* createFrameLockedQueue();

	/// Get a python-capable fixed-limit queue
	FixedLimitQueue* createFixedLimitQueue();

	/// Get a python-capable moving-average-limited queue
	MovingAverageQueue* createMovingAverageQueue();
}