#include "Scheduler/include/SimpleTime.h"
#include "Scheduler/include/Scheduler.h"

#include <iostream>

bool doit(unsigned long t)
{
	std::cout << t << std::endl;
}

int main()
{
	Scheduler::FrameLockedQueue frameLockedQueue;
	frameLockedQueue.addTask(&doit, 1.0f);

	Scheduler::FixedLimitQueue flq;
	Scheduler::MovingAverageQueue maq;
	
	Time::initialise();
	
	unsigned long t, ot;
	
	ot = Time::getMilliseconds();
	
	for (int i = 0; i < 10; ++i)
	{
		t = Time::getMilliseconds();

		frameLockedQueue.step(t - ot);
		flq.step(t - ot);
		maq.step(t - ot);

		ot = t;
	}
	
	return 0;
}

